
package a.b.c;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.List;

abstract class C1 {
	public abstract void f();
}

abstract class C2 extends C1 {
	abstract void g();
}

abstract class C3 extends C2 {
	abstract void h(int x, String s);
}

// Serializable: marker interface
//class OtherClass {
class OtherClass implements Serializable {
	private int a;
	private String s;

	OtherClass(int a, String s) {
		this.a = a;
		this.s = s;
	}
	
	static void modifyExPrivateField() throws IllegalArgumentException, IllegalAccessException, NoSuchFieldException, SecurityException {
//		SomeClass.field = 3;
		SomeClass.class.getDeclaredField("field")
			.set(null, 4);
	}

	@Override
	public String toString() {
		return "OtherClass [a=" + a + ", s=" + s + "]";
	}
}


@MyAnnot(value=123, name="asdva")
public class SomeClass {
	@MyAnnot2({4,5,6})
	private static int field;
	
	@MyAnnot2(value={4})
	int field2;
	
	@Deprecated
//	@Override
	@MyAnnot(value=123, name="asdf")
	public String toString(String s) {
		return "xyz";
	}

	public static void main(String[] args) throws Exception {
//		try (
//			var oos = new ObjectOutputStream(new FileOutputStream("out.nontxt"));
//		) {
//			oos.writeObject(new OtherClass(123, "xyz"));
//		}

		try (
			var ois = new ObjectInputStream(new FileInputStream("out.nontxt"));
		) {
			OtherClass obj = (OtherClass)ois.readObject();
			System.out.println(obj);
		}
		
	
	}

	@MyAnnot(123)
	@MyAnnot2(4)
	public static void main3(String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException, NoSuchFieldException, SecurityException, IllegalArgumentException, InvocationTargetException {
		Class<?> clazz = SomeClass.class;
		Class<SomeClass> clazz2 = SomeClass.class;
		Class<? extends SomeClass> clazz3 = SomeClass.class;
		int field3 = SomeClass.field;

//		Class<?> clazz4rossz = Class.forName("SomeClass");
		Class<?> clazz4 = Class.forName("a.b.c.SomeClass");

		System.out.println(clazz4.toString());

		clazz4.getAnnotations();
		MyAnnot annotation = clazz4.getAnnotation(MyAnnot.class);
		System.out.println("annot: " + annotation);
		System.out.println("annot: " + annotation.name());
		System.out.println("annot: " + annotation.value());

		Object newInstance = getNewInstance(clazz4);
		System.out.println(newInstance);

		Arrays.stream(MyAnnot.class.getAnnotations())
			.forEach(System.out::println);

		System.out.println("--------------");
		Arrays.stream(C3.class.getMethods())
		.forEach(System.out::println);
		System.out.println("--------------");
		Arrays.stream(C3.class.getDeclaredMethods())
		.forEach(System.out::println);
		
		Method method = C3.class.getDeclaredMethods()[0];
		System.out.println(method.getTypeParameters());
		System.out.println(method.getName());
		System.out.println(method);

		System.out.println(method.getParameters()[0]);
		System.out.println(method.getParameters()[0].getType().equals(int.class));
		
		
		Class<?> clazz5 = int.class;
		Class<?> clazz6 = int[].class;

		Field df = SomeClass.class.getDeclaredField("field");
		System.out.println(df);

		df.setAccessible(true);
//		OtherClass.modifyExPrivateField();
//		SomeClass.field = 3;
		System.out.println(SomeClass.field);

		Constructor<?> ctor = SomeClass.class.getConstructors()[0];
		Object newInstance2 = ctor.newInstance();
		System.out.println(newInstance2);

		Constructor<?> ctor2 = OtherClass.class.getDeclaredConstructors()[0];
		Object newInstance3 = ctor2.newInstance(1, "abc");
		System.out.println(newInstance3);
	}

	static <T> T getNewInstance(Class<T> someClass) throws InstantiationException, IllegalAccessException {
		return someClass.newInstance();
	}
	
	
	//	public static void main2(String[] args) {
//		System.out.println(new SomeClass());
//		System.out.println(new SomeClass().toString("abc"));
//
//		Thread thread = new Thread();
//		thread.stop();
//
//		Object arrayList = new ArrayList<>();
//
//		@SuppressWarnings("unchecked")
//		List<String> myList = (List)arrayList;
//
//		// class method statement expression
//		{
////			int a = f() + g() + h();
//			System.out.println();
//		}
//
//		List<String> myList2 = (List<String>)arrayList;
//	}

	@SafeVarargs
	static void f(List<String>... a) {
//		List<String>[] a
//		List[] a
	}

}

