import java.util.function.Function;

public class Parhuzamossag
{
	public static void main(String[] args) throws Exception {
		MyClass myClass = new MyClass();

		Thread t1 = new Thread(() -> {
			myClass.myFun1();
			myClass.myFun2();
		});
		Thread t2 = new Thread(() -> {
			myClass.myFun1();
			myClass.myFun2();
		});

		t1.start();		// versenyhelyzet (race condition)
		t2.start();
		t1.join();
		t2.join();

		System.out.println(myClass.myData1);
		System.out.println(myClass.myData2);
	}

	public static void main4(String[] args) throws Exception {
		Function<String, Thread> makeTxtThread = txt -> new Thread(() -> {
			for (int i = 0; i < 300000; ++i) {
				synchronized (System.out) {
//					 System.out.println(txt);
					for (char c : txt.toCharArray()) {
						System.out.print(c);
					}
					System.out.println();
				}
			}
		});

		makeTxtThread.apply("Hello").start();
		makeTxtThread.apply("vilag").start();
	}

	public static void main3a(String[] args) throws Exception {
//		Object lock = new Object();
		int[] counter = { 0 };
		String txt = "abc";

		Thread t1 = new Thread(() -> {
			for (int i = 0; i < 100_000; ++i) {
				// monitor; lock; kölcsönös kizárás
				synchronized (counter) {
					++counter[0];
				}
			}
		});

		Thread t2 = new Thread(() -> {
			for (int i = 0; i < 100_000; ++i) {
				synchronized (counter) {
//				 synchronized (txt) {
//				 synchronized (lock) {
//				 synchronized (Parhuzamossag.class) {
//				 synchronized (System.out) {
					++counter[0];
				}
			}
		});

		// t1.run();
		// t2.run();
		t1.start();		// versenyhelyzet (race condition)
		t2.start();
		t1.join();
		t2.join();

		System.out.println(counter[0]);
	}

	// public static void main(String[] args) throws Exception {
	//	// final int counter = 0;
	//	int counter = 0;		// nem tud (effectively) final lenni

	//	Thread t1 = new Thread(() -> {
	//		for (int i = 0; i < 100_000; ++i) {
	//			++counter;
	//		}
	//	});

	//	Thread t2 = new Thread(() -> {
	//		for (int i = 0; i < 100_000; ++i) {
	//			++counter;
	//		}

	//	});
	//	t1.start();
	//	t2.start();
	//	t1.join();
	//	t2.join();

	//	System.out.println(counter);
	// }

	public static void main2(String[] args) throws Exception {
		Runnable r = () -> {
			for (int i = 0; i < 300000; ++i) {
				System.out.println("Hello vilag " + i);
			}
		};

		// NEM párhuzamos
//		 r.run();
//		 r.run();
//		 r.run();
//		 r.run();

		// new Thread(r);

		// NEM párhuzamos
		// new Thread(r).run();
		// new Thread(r).run();
		// new Thread(r).run();
		// new Thread(r).run();

//		 Thread thread2 = new Thread(r);
//		 Thread thread = thread2;
//		 thread.setPriority(9);
//		 thread.start();
//		 thread.setPriority(0);
//		 thread2.start();
//		 new Thread(r).start();
//		 new Thread(r).start();

//		 new Thread(() -> {
//			for (int i = 0; i < 3000; ++i) {
//				System.out.println("Hello vilag " + i);
//			}
//		 }).start();

		// Thread x = new Thread(szovegesSzal("x", 3000)).start();
		// new Thread(szovegesSzal("a", 3000)).start();
		// new Thread(szovegesSzal("b", 3000)).start();
		// new Thread(szovegesSzal("c", 3000)).start();
		Thread t = new Thread(szovegesSzal("d", 30));
		t.start();
		Thread te = new Thread(szovegesSzal("e", 30));
		te.start();

		 // tilos használni:
//		  t.stop();
//		  System.exit(123);

//		Thread t1 = new MyThread();
//		Thread t2 = new Thread(new MyRunnable());

		// // // t1.start();
		// // // t2.start();

		// // // t1.join();
		// // // t2.join();
		t.join();
		te.join();

		System.out.println("All done.");

	}

	static Runnable szovegesSzal(String id, int lepesszam) {
		return () -> {
			for (int i = 0; i < lepesszam; ++i) {
				System.out.println(id + " " + i);
			}
		};
	}


//	public static void main(String[] args) {
//		Thread t = new Thread(() -> {
//			try {
//				Thread.sleep(30_000);
//			} catch (InterruptedException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			
//			System.out.println("Done.");
//		});
//		t.start();
//
//		try {
//			Thread.sleep(1000);
//		} catch (InterruptedException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//
//		t.interrupt();
//	}
}


class MyThread extends Thread {
	int threadData;

	public void run() {
		System.out.println("MyThread");
	}
}

class SomeOtherBaseClass {}

class MyRunnable extends SomeOtherBaseClass implements Runnable {
	public void run() {
		System.out.println("MyRunnable");
	}

	public Thread runMe() {
		Thread thread = new Thread(this);
		thread.start();
		return thread;
	}
}

class MyClass {
	int myData1;
	int myData2;

	public void myFun1() {
		for (int i = 0; i < 100000; ++i) {
			++myData1;
		}
	}

	public synchronized void myFun2() {
		// synchronized (this) {
			for (int i = 0; i < 100000; ++i) {
				++myData2;
			}
		// }
	}

	public void myFun3() {
		for (int i = 0; i < 100000; ++i) {
			synchronized (this) {
				++myData2;
			}
		}
	}
}

